/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Map-Service
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-09-17, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  */

package jaugment2.map;

  //JDK
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
  //JINI
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.UnknownLeaseException;
import net.jini.core.lease.Lease;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.UnknownEventException;

  //project

  //helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper



/**
 * Title:        jAugment - Map
 * Description:  A simple map with GPS-support planned
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Marcus Wolschon Suran@gmx.net
 * @version 1.0
 */

public class MapGPSListener  extends UnicastRemoteObject  implements RemoteEventListener
{

  private MapService service = null;
  public MapGPSListener(MapService service) throws RemoteException
  {
   this.service = service;
  }


  /** React to events from our service.
    */
  public void notify(RemoteEvent evt) throws UnknownEventException, RemoteException
  {

   if(!(evt instanceof GPSProxyIF.GPSServiceEvent))
     throw(new UnknownEventException("expected GPSProxyIF.GPSServiceEvent"));

   GPSProxyIF.GPSServiceEvent e = (GPSProxyIF.GPSServiceEvent)evt;
   switch((int)evt.getID())
     {
      case GPSProxyIF.GPSServiceEvent.EVID_GPSPOSITIONUPDATED:
         {
          GPSProxyIF.GPSPosition gpspos= e.getCurrentPosition();

          service.setCurrentPosition(new MapServiceProxyIF.Position(gpspos.getLatitude(), gpspos.getLongtitude())); //TODO: test
          return;
         }
      default:
       throw(new UnknownEventException("unknown Event-ID"));
     }
  }

}