/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: Map-Service
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-09-12, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  *       - implement it
  *       - make it work
  */
package jaugment2.map;

  //JDK
//import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
import java.util.LinkedList;
import java.io.FileInputStream;
import java.util.*;
import java.io.*;
  //JINI
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.UnknownLeaseException;
import net.jini.core.lease.Lease;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.event.UnknownEventException;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
  //project
import jaugment2.jini.simpleService.VerySimpleService;
import jaugment2.helpers.Logger;
import jaugment2.jini.SimpleLandlord;
import jaugment2.jini.SimpleLandlord.LeaseListener;
import jaugment2.jini.SimpleLandlord.EventRegistration;

//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


/** an implementation if GPSProxyIF based on thhe gps-class of Sulawesi,
 *  Copyright 1998 Neill J Newman <njnewm@essex.ac.uk>. It uses a command-
 *  line tool to get the data of a GPS-receiver.
 *
 */
public class NMEAGPSService extends VerySimpleService  implements GPSProxyIF
{
 private static final boolean debugThis = true;
  private Thread gps =  null;

  public NMEAGPSService() throws java.rmi.RemoteException , java.io.IOException
  {
   if(debugThis)Logger.debug.println("DEBUG: NMEAGPSService starting up...");
   landLord = new SimpleLandlord(simpleLeaselistener);
   init(this, jaugment2.map.GPSProxyIF.class);


   //TODO: make this configurable
   currentPos = new GPSProxyIF.GPSPosition(0,0);


//TODO
  }


  public String getComment()
  {return("A GPS-location-service based of the sulawesi-gps-class");};
  public String getCreator()
  {return("Marcus Wolschon <Suran@gmx.net>, original code by Nils Elgaard Larsen <elgaard@diku.dk>");};
  public UIDescriptor getUIDescriptor()
  {
   if(debugThis)Logger.debug.println("DEBUG: NMEAGPSService.getUIDescriptor() called...");
   return(null);
  };





 GPSProxyIF.GPSPosition currentPos = new GPSProxyIF.GPSPosition(500,500);


 public GPSProxyIF.GPSPosition getCurrentPosition() throws RemoteException
 {
  return(currentPos);
 }








   private LinkedList listenerRegistrations[] = new LinkedList[]{new LinkedList(),new LinkedList()};

  /**
   * Helper-class for our Landlord.
   */
  private LeaseListener simpleLeaselistener = new LeaseListener()
  {
   public void leaseCanceled(int type, Object reg, int newcount)
   {
//    EventRegistration reg2 = (EventRegistration)reg;
    //TODO
   };
  };

  private SimpleLandlord landLord;

  private void fireEvent(int type)
  {
   if(debugThis)Logger.debug.println("DEBUG: [NMEAGPSService:fireEvent] I have "+listenerRegistrations[type].size()+" registrations");
   for(int i=0; i<listenerRegistrations[type].size(); i++)
     {
      try
        {                     //TODO: do this asyncronously
         EventRegistration entry = (EventRegistration)listenerRegistrations[type].get(i);
         if(debugThis)Logger.debug.println("DEBUG: [NMEAGPSService:fireEvent] delivering event type="+type+" subscribedFor="+entry.subscribedFor+" entry.subscribedFor & type="+(entry.subscribedFor & type));
         if( (entry.subscribedFor & type) != 0)
         entry.listener.notify(
                               new GPSProxyIF.GPSServiceEvent(getProxy(),
                                                     type,
                                                     entry.seq++,
                                                     entry.handback,
                                                     currentPos
                                                    )
                              );
        }
      catch(RemoteException ex)
        {
         Logger.err.println("ERROR: [NMEAGPSService:fireEvent] could not deliver event");
         ex.printStackTrace(Logger.err);
        }
      catch(UnknownEventException ex)
        {
         Logger.err.println("ERROR: [NMEAGPSService:fireEvent] could not deliver event - the receiver does not know it");
         ex.printStackTrace(Logger.err);
        }
     }
  };

  /** Subscribe for events
    */
  public Lease addListener(RemoteEventListener listener, MarshalledObject handback, int registerfor) throws RemoteException, LeaseDeniedException, IllegalStateException
  {
   if(listener==null)
     return(null);

   try
     {
      EventRegistration reg = new EventRegistration(listener, handback);
      Lease   l = landLord.grantLease(0, reg, 2*60*10);

      if(l != null)
        {
          // tokenize the expression
         if(debugThis)Logger.debug.println("DEBUG: [NMEAGPSService] addListener expr=\""+registerfor+"\"");

         for(int i=1; i<(2*registerfor) && (i<listenerRegistrations.length); i=i*2)
            if((i & registerfor) == i)
             {
              listenerRegistrations[i].add(reg);
             };
        };

      return(l);
     }
   catch(Exception ex)
     {
      ex.printStackTrace(Logger.err);
     }
   return(null);
  };



//--------------------------------------------------------------------------------

}








